    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -------------------------
    028     * LengthConstraintType.java
    029     * -------------------------
    030     * (C) Copyright 2005-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes:
    036     * --------
    037     * 08-Feb-2004 : Version 1 (DG);
    038     *
    039     */
    040
    041    package org.jfree.chart.block;
    042
    043    import java.io.ObjectStreamException;
    044    import java.io.Serializable;
    045
    046    /**
    047     * Defines tokens used to indicate a length constraint type.
    048     */
    049    public final class LengthConstraintType implements Serializable {
    050
    051        /** For serialization. */
    052        private static final long serialVersionUID = -1156658804028142978L;
    053
    054        /** NONE. */
    055        public static final LengthConstraintType NONE
    056            = new LengthConstraintType("LengthConstraintType.NONE");
    057
    058        /** Range. */
    059        public static final LengthConstraintType RANGE
    060            = new LengthConstraintType("RectangleConstraintType.RANGE");
    061
    062        /** FIXED. */
    063        public static final LengthConstraintType FIXED
    064            = new LengthConstraintType("LengthConstraintType.FIXED");
    065
    066        /** The name. */
    067        private String name;
    068
    069        /**
    070         * Private constructor.
    071         *
    072         * @param name  the name.
    073         */
    074        private LengthConstraintType(String name) {
    075            this.name = name;
    076        }
    077
    078        /**
    079         * Returns a string representing the object.
    080         *
    081         * @return The string.
    082         */
    083        public String toString() {
    084            return this.name;
    085        }
    086
    087        /**
    088         * Returns <code>true</code> if this object is equal to the specified
    089         * object, and <code>false</code> otherwise.
    090         *
    091         * @param obj  the object (<code>null</code> permitted).
    092         *
    093         * @return A boolean.
    094         */
    095        public boolean equals(Object obj) {
    096            if (this == obj) {
    097                return true;
    098            }
    099            if (!(obj instanceof LengthConstraintType)) {
    100                return false;
    101            }
    102            LengthConstraintType that = (LengthConstraintType) obj;
    103            if (!this.name.equals(that.toString())) {
    104                return false;
    105            }
    106            return true;
    107        }
    108
    109        /**
    110         * Returns a hash code value for the object.
    111         *
    112         * @return The hashcode
    113         */
    114        public int hashCode() {
    115            return this.name.hashCode();
    116        }
    117
    118        /**
    119         * Ensures that serialization returns the unique instances.
    120         *
    121         * @return The object.
    122         *
    123         * @throws ObjectStreamException if there is a problem.
    124         */
    125        private Object readResolve() throws ObjectStreamException {
    126            if (this.equals(LengthConstraintType.NONE)) {
    127                return LengthConstraintType.NONE;
    128            }
    129            else if (this.equals(LengthConstraintType.RANGE)) {
    130                return LengthConstraintType.RANGE;
    131            }
    132            else if (this.equals(LengthConstraintType.FIXED)) {
    133                return LengthConstraintType.FIXED;
    134            }
    135            return null;
    136        }
    137
    138    }